/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import * as runtime from '../runtime';
import {CloudEvent, CloudEventFromJSON, CloudEventToJSON} from '../models';

export interface EventsControllerImplApiHandleEventRequest {
  cloudEvent: CloudEvent;
}

/**
 *
 */
export class EventsControllerImplApi extends runtime.BaseAPI {
  /**
   * Handle events in CloudEvents format
   */
  async handleEventRaw(
    requestParameters: EventsControllerImplApiHandleEventRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<runtime.ApiResponse<void>> {
    if (
      requestParameters.cloudEvent === null ||
      requestParameters.cloudEvent === undefined
    ) {
      throw new runtime.RequiredError(
        'cloudEvent',
        'Required parameter requestParameters.cloudEvent was null or undefined when calling handleEvent.'
      );
    }

    const queryParameters: any = {};

    const headerParameters: runtime.HTTPHeaders = {};

    headerParameters['Content-Type'] = 'application/json';

    const response = await this.request(
      {
        path: `/api/gateway/iso20022/demo/event`,
        method: 'POST',
        headers: headerParameters,
        query: queryParameters,
        body: CloudEventToJSON(requestParameters.cloudEvent),
      },
      initOverrides
    );

    return new runtime.VoidApiResponse(response);
  }

  /**
   * Handle events in CloudEvents format
   */
  async handleEvent(
    requestParameters: EventsControllerImplApiHandleEventRequest,
    initOverrides?: RequestInit | runtime.InitOverideFunction
  ): Promise<void> {
    await this.handleEventRaw(requestParameters, initOverrides);
  }
}
